<html lang="en" xlmns:th="http://www/thymleaf.org" xlmns:layout="http://ultraq.net.nz/thymeleaf/layout"
	layout:decorate="~{fragments/layout}">

<head>
	<title>Orders Pages</title>
</head>

<body>
	<div layout:fragment="content">
		<h1>Orders API Pages</h1>
		<br>
		<div class="p-3 mb-2 bg-primary text-white">
			<button type="button" class="btn btn-light" onclick="newOrder()">
				New Order
			</button>
			<button type="button" class="btn btn-light" onclick="getOrderList()">
				List Amount
			</button>
			<!--<button type="button" class="btn btn-light" onclick="">
				New Trans
			</button>-->
		</div>
		<div id="main-contain"></div>
		<div id="data-list"></div>
		<div id="header-list"></div>


		<script>
			var tempStock = 0;
			var temp = ""
			function newOrder() {
				$.ajax({
					url: '/api/orderheaderid',
					type: 'get',
					contentType: 'application/json',
					success: function (headerId) {
						if (headerId == 0) {
							var input = '{'
							input += '"amount" : "",'
							input += '"reference" : ""'
							input += '}'
							$.ajax({
								url: '/api/orderheader/add',
								type: 'post',
								contentType: 'application/json',
								data: input,
								success: function () {
									newOrder()
								}
							})
						} else {
							getAllProduct(headerId)
							getAllOrderDetail(headerId)
						}
					}
				})
			}

			function getAllProduct(headerId) {
				$.ajax({
					url: "/api/product",
					type: "get",
					contentType: "application/json",
					success: function (data) {
						var str = "<table class='table'>"
						str += "<tr>"
						str += "<td>Product</td>"
						str += "<td><select class='form-control' id='product_id' onchange='priceByCategoryId(this.value)'>"
						str += "<option>-- Select Product --</option>"
						for (var i = 0; i < data.length; i++) {
							str += "<option value=" + data[i].id + ">" + data[i].productName + "</option>"
						}
						str += "</select>"
						str += "</tr>"
						str += "<tr>"
						str += "<td>Price</td>"
						str += "<td><input class='form-control' type='text' id='product_price' disabled></td>"
						str += "</tr>"
						str += "<tr>"
						str += "<td>Quantity</td>"
						str += "<td><input class='form-control' onkeyup='validateStock()' type='number' id='quantity'></td>"
						str += "</tr>"
						str += "<tr>"
						str += "<td><button class='btn btn-success' onclick='addOrder(" + headerId + ")'>Tambah Item</button></td>"
						str += "</tr>"
						str += "</table>"

						$('#header-list').html(' ')
						$('#main-contain').html(str)

					}

				})
			}
			function priceByCategoryId(id) {
				if (id > 0) {
					$.ajax({
						url: '/api/product/' + id,
						type: 'get',
						contentType: 'application/json',
						success: function (data) {
							$('#product_price').val(data.productPrice)
							$('#quantity').attr('max', data.productStock)
							$('#quantity').attr('min', 1)
							tempStock = data.productStock;
						}
					})
				} else {
					$('#product_price').val(0)
				}
			}

			function validateStock() {
				if ($('#quantity').val() > tempStock) {
					$('#quantity').val(tempStock)
				}
			}

			function addOrder(headerId) {
				//console.log(id)

				var headerid = headerId;
				var price = $('#product_price').val()
				var productid = $('#product_id').val()
				var quantity = $('#quantity').val()

				var input = '{'
				input += '"headerId":' + headerid + ','
				input += '"price":' + price + ','
				input += '"productId":' + productid + ','
				input += '"quantity":' + quantity + ''
				input += '}'

				$.ajax({
					url: '/api/orderdetail/add',
					type: 'post',
					contentType: 'application/json',
					data: input,
					success: function () {
						getAllOrderDetail(headerid)
					}
				})
			}

			function getAllOrderDetail(headerId) {
				$.ajax({
					url: '/api/orderdetail/list/' + headerId,
					type: 'get',
					contentType: 'application/json',
					success: function (data) {
						var str = "<table class='table' cellpadding='5'>"
						//str += "<thead>"
						str += "<tr>"
						str += "<td> Reference </td>"
						str += "<td> Product </td>"
						str += "<td> Price </td>"
						str += "<td> Quantity </td>"
						str += "<td> Total </td>"
						//str += "<td> Remove </td>"
						str += "</tr>"
						//str += "</thead>"
						//str += "<tbody>"
						var totalAmount = 0
						for (var i = 0; i < data.length; i++) {
							var total = data[i].quantity * data[i].price
							str += "<tr>"
							str += "<td>" + data[i].orderHeader.reference + "</td>"
							str += "<td>" + data[i].product.productName + "</td>"
							str += "<td>" + data[i].price + "</td>"
							str += "<td>" + data[i].quantity + "</td>"
							str += "<td>" + total + "</td>"
							//str += "<td><button class='btn btn-danger'; onclick=;>Delete</button></td>"
							str += "</tr>"

							totalAmount += total
						}
						str += "<td colspan='4'> Total Amount </td>"
						str += "<td><input id='total_amount' value=" + totalAmount + " disabled></td>"
						str += "</tr>"
						str += "<tr>"
						str += "<td><button class='btn btn-primary' onclick = 'confirmCheckout(" + headerId + ")'>Checkout</button></td>"
						str += "</tr>"
						str += "</table>"

						//$('#header-list').html(' ')
						$('#data-list').html(str)

					}
				})
			}

			function confirmCheckout(headerId) {
				$.ajax({
					url: '/api/orderdetail/list/' + headerId,
					type: 'get',
					contentType: 'application/json',
					success: function (data) {
						var str = "<h5>Apakah anda yakin ingin checkout barang ini : </h5>"
						str += "<table class='table table-border-borderless'>"
						str += "<thead>"
						str += "<tr>"
						str += "<th>No</th>"
						str += "<th>Product Name</th>"
						str += "<th>Quantity</th>"
						str += "</tr>"
						str += "</thead>"
						str += "<tbody>"

						var reference = 0
						for (var i = 0; i < data.length; i++) {
							str += "<tr>"
							str += "<td>" + (i + 1) + "</td>"
							str += "<td>" + data[i].product.productName + "</td>"
							str += "<td>" + data[i].quantity + "</td>"
							str += "</tr>"

							reference = data[i].orderHeader.reference
						}
						str += "</tbody>"
						str += "</table>"
						$('.modal-title').html('Checkout')
						$('.modal-body').html(str)
						$('#btn-save').off('click').on('click', function () {doneProcess(headerId, reference)}).html('Checkout')
						$('#modal').modal('show')
					}
				})
			}

			function doneProcess(headerId, reference) {
				var input = '{'
				input += '"id":' + headerId + ','
				input += '"amount":"' + $('#total_amount').val() + '",'
				input += '"reference":"' + reference + '"'
				input += '}'

				$.ajax({
					url: '/api/orderheader/done',
					type: 'put',
					contentType: 'application/json',
					data: input,
					success: function () {
						window.location.href = 'indexapi'

					}
				})
			}

			function getOrderList() {
				$.ajax({
					url: '/api/orderheader',
					type: 'get',
					contentType: 'application/json',
					success: function (data) {
						var input = "<table class='table' 'border=1'>"
						input += "<thead>"
						input += "<tr>"
						input += "<th>No.</th>"
						input += "<th>Reference</th>"
						input += "<th>Amount</th>"
						input += "</tr>"
						input += "</thead>"
						input += "<tbody>"
						for (var i = 0; i < data.length; i++) {
							input += "<tr>"
							input += "<td>" + (i + 1) + "</td>"
							input += "<td>" + data[i].reference + "</td>"
							input += "<td>" + data[i].amount + "</td>"
							input += "</tr>"
						}
						input += "</tbody>"
						input += "</table>"

						$('#main-contain').html(' ')
						$('#data-list').html(' ')
						$('#header-list').html(input)
					}
				})
			}
		</script>
	</div>
</body>

</html>